// This file is part of mqtt. It is subject to the license terms in the COPYRIGHT file found in the top-level directory of this distribution and at https://raw.githubusercontent.com/lemonrock/mqtt/master/COPYRIGHT. No part of predicator, including this file, may be copied, modified, propagated, or distributed except according to the terms contained in the COPYRIGHT file.
// Copyright © 2017 The developers of mqtt. See the COPYRIGHT file in the top-level directory of this distribution and at https://raw.githubusercontent.com/lemonrock/mqtt/master/COPYRIGHT.


#[derive(Debug, Copy, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub struct PointerPathTypeBasedAliasAnalysisNode(PathTypeBasedAliasAnalysisNode);

impl PointerPathTypeBasedAliasAnalysisNode
{
	#[inline(always)]
	pub fn new(context: &Context, offsetIntoBaseType: u64, baseType: &TypeBasedAliasAnalysisNode) -> Self
	{
		PointerPathTypeBasedAliasAnalysisNode(PathTypeBasedAliasAnalysisNode::new(context, offsetIntoBaseType, baseType, TypeBasedAliasAnalysisNode::any_pointer()))
	}
}

impl PointerPathTypeBasedAliasAnalysisNode
{
	#[inline(always)]
	pub fn asPathTypeBasedAliasAnalysisNode<'a>(&'a self) -> &'a PathTypeBasedAliasAnalysisNode
	{
		&self.0
	}
}
